#include "m_pd.h"
#include "math.h"
 
typedef struct tracks
{
  t_object x_ob;
  int x1_i[2048], x1_elem01[2048], x1_elem02[2048], x1_s[2048], x2_i[2048], x2_elem01[2048], x2_elem02[2048], x2_s[2048];
  float x1_elem03[2048], x1_elem04[2048], x1_elem05[2048], x1_elem06[2048], x1_elem07[2048], x1_elem08[2048], x1_elem09[2048], x1_elem10[2048], x1_elem11[2048], x1_elem12[2048], x1_elem13[2048], x1_elem14[2048], x1_elem15[2048], x1_elem16[2048];
  float x2_elem03[2048], x2_elem04[2048], x2_elem05[2048], x2_elem06[2048], x2_elem07[2048], x2_elem08[2048], x2_elem09[2048], x2_elem10[2048], x2_elem11[2048], x2_elem12[2048], x2_elem13[2048], x2_elem14[2048], x2_elem15[2048], x2_elem16[2048];;
  int i_reg1[2048], i_reg2[2048];
  float w[10], w_sum;
  float max_dist;
  int prev_pts, pts, report, dimen;
  t_outlet *out01, *out02, *out03;
} t_tracks;


void tracks_weights(t_tracks *x, t_symbol *selector, int argcount, t_atom *argvec)
{
    int i;
    for (i = 0; i < argcount; i++) {
    	if (argvec[i].a_type == A_FLOAT) {
			if		(i == 0)	{x->w[i] = argvec[i].a_w.w_float;}
			else if (i == 1)	{x->w[i] = argvec[i].a_w.w_float;}
			else if (i == 2)	{x->w[i] = argvec[i].a_w.w_float;}
		}   
	}
	x->w_sum = 0;
	for (i = 0; i < x->dimen; i++) x->w_sum += x->w[i];
	post ("TRACKS: dimension = %i", x->dimen);
	post ("TRACKS: total weight = %f", x->w_sum);
	for (i = 0; i < x->dimen; i++) post("TRACKS: w%d = %f (%f)", i+1, x->w[i], x->w[i]/x->w_sum);
}

void tracks_input(t_tracks *x, t_symbol *selector, int argcount, t_atom *argvec)
{
    int i;
    for (i = 0; i < argcount; i++) {
    	if (argvec[i].a_type == A_FLOAT) {
			if		(i == 0)	{x->x2_i[x->pts]	  = (int)	argvec[i].a_w.w_float;}
			else if (i == 1)	{x->x2_elem01[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 2)	{x->x2_elem02[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 3)	{x->x2_elem03[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 4)	{x->x2_elem04[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 5)	{x->x2_elem05[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 6)	{x->x2_elem06[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 7)	{x->x2_elem07[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 8)	{x->x2_elem08[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 9)	{x->x2_elem09[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 10)	{x->x2_elem10[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 11)	{x->x2_elem11[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 12)	{x->x2_elem12[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 13)	{x->x2_elem13[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 14)	{x->x2_elem14[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 15)	{x->x2_elem15[x->pts] =			argvec[i].a_w.w_float;}
			else if (i == 16)	{x->x2_elem16[x->pts] =			argvec[i].a_w.w_float;}
			x->x2_s[x->pts] = 1; 
		}   
	}
//	post("i = %d, x = %d, y = %d", x->x2_i[x->pts], x->x2_elem01[x->pts], x->x2_elem02[x->pts]);
//	post("pts = %d", x->pts);
	x->pts++; 
}

void tracks_ft1(t_tracks *x, t_floatarg g)
{
    x->max_dist = g;
	post("TRACKS: maxdist = %f", x->max_dist);
}

void tracks_clear(t_tracks *x)
{
	int z, j, i;
	t_atom at[3];	
	z = 0;
	for (j = 0; j < x->prev_pts; j++) {  // for every old point
		if (x->x1_s[j] == 1) {
			x->i_reg1[z] = -2;
			x->i_reg2[z] = x->x1_i[j];
			z++;
		}
		if (z == x->prev_pts) break;
	}
	for (i = 0; i < z; i++) {
		SETFLOAT(at,	x->i_reg1[i]);
		SETFLOAT(at+1,	x->i_reg2[i]);
		outlet_list(x->out03, 0, 2, at);
	}
	x->prev_pts = x->pts = 0;
}

void tracks_dimen(t_tracks *x, t_symbol *selector, int argcount, t_atom *argvec)
{
	int i = 0;
	x->dimen = (int) argvec[i].a_w.w_float;
	post ("TRACKS: dimension = %i", x->dimen);
	x->w_sum = 0;
	for (i = 0; i < x->dimen; i++) x->w_sum += x->w[i];
}

void tracks_max_distance(t_tracks *x, t_symbol *selector, int argcount, t_atom *argvec)
{
	int i = 0;
	x->max_dist = (int) argvec[i].a_w.w_float;
	post ("TRACKS: maximum distance = %f", x->max_dist);
}

void tracks_spit(t_tracks *x)
{
	
//	post("new");
	int i, j, z, new_pts, j_tmp, i_tmp, assigned;
	int free_i[2048];
	t_atom at[18];
	double dist, dist_temp;
	j_tmp = i_tmp = assigned = z = 0;

	new_pts = x->pts - x->prev_pts;
	for (i = 0; i < 2048; i++) {
		free_i[i] = 1;
	}	
 	if (new_pts >= 0) { // if there are more or equal new pts than previous pts //	post (">=");
		for (i = 0; i < x->prev_pts; i++) { // for each previous pt (if there are 0 previous all are new...)
			dist_temp = 10000000; // (just a big number...)
			j_tmp = -1; 
			for (j = 0; j < x->pts; j++) {  // find the closest new one.
				if (x->x2_s[j] == 1) {
					if (x->dimen == 1) {
						dist = fabs(x->x1_elem01[i] - x->x2_elem01[j]);
					}
					else if (x->dimen == 2) {
						dist = sqrt(((x->x1_elem01[i] - x->x2_elem01[j])*(x->x1_elem01[i] - x->x2_elem01[j]))*x->w[0] + 
									((x->x1_elem02[i] - x->x2_elem02[j])*(x->x1_elem02[i] - x->x2_elem02[j]))*x->w[1]	);
					}
					else if (x->dimen == 3) {
						dist = cbrt(((x->x1_elem01[i] - x->x2_elem01[j])*(x->x1_elem01[i] - x->x2_elem01[j]))*x->w[0] + 
									((x->x1_elem02[i] - x->x2_elem02[j])*(x->x1_elem02[i] - x->x2_elem02[j]))*x->w[1] +
									((x->x1_elem03[i] - x->x2_elem03[j])*(x->x1_elem03[i] - x->x2_elem03[j]))*x->w[2]	);
					}
					else {
						post("wrong dimension, only 1, 2 and 3");
					}
					if (dist < dist_temp && dist < x->max_dist) {
						dist_temp	= dist;
						j_tmp		= j; //		post("dist = %f", dist);
					}
			//		post("dist = %f", dist);
				}
				else continue;
			}
			if (j_tmp >= 0) { // that is, if we found an index != -1
				x->x2_s[j_tmp]		= 0;				// set the state of the new tip to 0
				x->x1_s[i]			= 0;				// set the state of the old tip to 0
				x->i_reg1[z] 		= x->x2_i[j_tmp];
				x->x2_i[j_tmp]		= x->x1_i[i];		// assign the index of previous tip
				x->i_reg2[z] 		= x->x2_i[j_tmp];		
				free_i[x->x2_i[j_tmp]]	= 0;
				assigned++; z++;//	post("assigned %d", x->x1_i[i] );
			}
			if (assigned == x->pts) {
				break;
			}
		} 
		if (assigned < x->pts) { // the old points left behind
			for (j = 0; j < x->prev_pts; j++) {  // for every old point
				if (x->x1_s[j] == 1) {
					x->x1_s[j] = 0;
					x->i_reg1[z] = -2;
					x->i_reg2[z] = x->x1_i[j];
					free_i[x->x1_i[j]] = 0;
					z++;
				}
				if (assigned == x->prev_pts) break;
			}
		}
		while (assigned != x->pts) { //			post("while");
			for (i = 0; i < x->pts; i++) {
				if (x->x2_s[i] == 1) {
					for (j = 0; j < 2048; j++) {
						if (free_i[j] == 1) {
							x->x2_s[i] = 0;
							free_i[j] = 0;
							x->x2_i[i] = j;
							x->i_reg1[z] = -1;
							x->i_reg2[z] = x->x2_i[i]; //post("assign extra, index = %d", j);
							assigned++; z++;
							break;
						}
					}
				}
			}
		}
	}
	else if (new_pts < 0) { // if there are less new pts than previous pts //	post ("<");
		for (i = 0; i < x->pts; i++) { // for each new pt
			dist_temp = 10000000;
			j_tmp = -1;
			for (j = 0; j < x->prev_pts; j++) {  // find the closest old one.
				if (x->x1_s[j] == 1) {
					dist = sqrt(((x->x1_elem01[j] - x->x2_elem01[i])*(x->x1_elem01[j] - x->x2_elem01[i])) + 
							((x->x1_elem02[j] - x->x2_elem02[i])*(x->x1_elem02[j] - x->x2_elem02[i]))	);
					if (dist < dist_temp && dist < x->max_dist) {
						dist_temp	= dist;
						j_tmp		= j;
//						post("dist = %f", dist);
					}	
				}
				else continue;
			}
			if (j_tmp >= 0) {
				x->x1_s[j_tmp]		= 0;		// set the state of the new tip to 0
				x->i_reg1[z] 		= x->x2_i[i];
				x->x2_i[i]		= x->x1_i[j_tmp];	// assign the index of previous tip		
				x->i_reg2[z] 		= x->x2_i[i];
				assigned++; 
				z++; //		post("assigned %d", x->x1_i[j_tmp] );
			}		
			if (assigned == x->pts) {
				break;
			}	
		} 
		for (j = 0; j < x->prev_pts; j++) {  // for every old point
			if (x->x1_s[j] == 1) {
				x->i_reg1[z] = -2;
				x->i_reg2[z] = x->x1_i[j];
				z++;
			}
			if (z == x->prev_pts) break;
		}
	}			 
	for (i = 0; i < x->pts; i++) {
		SETFLOAT(at,	x->x2_i[i]);
		SETFLOAT(at+1,	x->x2_elem01[i]);
		SETFLOAT(at+2,	x->x2_elem02[i]);
		SETFLOAT(at+3,	x->x2_elem03[i]);
		SETFLOAT(at+4,	x->x2_elem04[i]);
		SETFLOAT(at+5,	x->x2_elem05[i]);
		SETFLOAT(at+6,	x->x2_elem06[i]);
		SETFLOAT(at+7,	x->x2_elem07[i]);
		SETFLOAT(at+8,	x->x2_elem08[i]);
		SETFLOAT(at+9,	x->x2_elem09[i]);
		SETFLOAT(at+10,	x->x2_elem10[i]);
		SETFLOAT(at+11,	x->x2_elem11[i]);
		SETFLOAT(at+12,	x->x2_elem12[i]);
		SETFLOAT(at+13,	x->x2_elem13[i]);
		SETFLOAT(at+14,	x->x2_elem14[i]);
		SETFLOAT(at+15,	x->x2_elem15[i]);
		SETFLOAT(at+16,	x->x2_elem16[i]);
		outlet_list(x->out01, 0, 17, at);
	}
	for (i = 0; i < x->pts; i++) {
		x->x1_i[i]	= x->x2_i[i]; 
		x->x1_elem01[i]	= x->x2_elem01[i];
		x->x1_elem02[i]	= x->x2_elem02[i];
		x->x1_elem03[i]	= x->x2_elem03[i];
		x->x1_elem04[i]	= x->x2_elem04[i];
		x->x1_elem05[i]	= x->x2_elem05[i];
		x->x1_elem06[i]	= x->x2_elem06[i];
		x->x1_elem07[i]	= x->x2_elem07[i];
		x->x1_elem08[i]	= x->x2_elem08[i];
		x->x1_elem09[i]	= x->x2_elem09[i];
		x->x1_elem10[i]	= x->x2_elem10[i];
		x->x1_elem11[i]	= x->x2_elem11[i];
		x->x1_elem12[i]	= x->x2_elem12[i];
		x->x1_elem13[i]	= x->x2_elem13[i];
		x->x1_elem14[i]	= x->x2_elem14[i];
		x->x1_elem15[i]	= x->x2_elem15[i];
		x->x1_elem16[i]	= x->x2_elem16[i];
		x->x1_s[i]	= 1;
	}
	for (i = 0; i < z; i++) {
		SETFLOAT(at,	x->i_reg1[i]);
		SETFLOAT(at+1,	x->i_reg2[i]);
		outlet_list(x->out02, 0, 2, at);
	}
	x->prev_pts = x->pts;
	x->pts = 0;
	SETFLOAT(at,	1);
	outlet_list(x->out03, 0, 1, at);
}




t_class *tracks_class;

void *tracks_new(t_symbol *selector, int argcount, t_atom *argvec)
{
	int i = 0;
	post("TRACKS: Jaime Oliver, 2010 - www.jaimeoliver.pe");
    t_tracks *x = (t_tracks *)pd_new(tracks_class);
//	inlet_new(&x->x_ob, &x->x_ob.ob_pd, gensym("float"), gensym("ft1"));
	x->prev_pts = x->pts = 0;
	x->max_dist = 30;
																												
	x->dimen = 1;
	for (i = 0; i < 10; i++) x->w[i] = 1;
	x->w_sum = 0;
	for (i = 0; i < x->dimen; i++) x->w_sum += x->w[i]; 																								
																							
	post("TRACKS: defaults: dimension = 1, maximum distance = 30");
	x->out01 = outlet_new(&x->x_ob, &s_list);
	x->out02 = outlet_new(&x->x_ob, &s_list);
	x->out03 = outlet_new(&x->x_ob, &s_list);
    return (void *)x;
}

void tracks_setup(void)
{
    	/* We specify "A_GIMME" as creation argument for both the creation
	routine and the method (callback) for the "xy" message.  */
    tracks_class = class_new(gensym("tracks"), (t_newmethod)tracks_new,
    	0, sizeof(t_tracks), 0, A_GIMME, 0);
    class_addmethod(tracks_class, (t_method)tracks_input, gensym("input"), A_GIMME, 0);
	class_addmethod(tracks_class, (t_method)tracks_dimen, gensym("dimen"), A_GIMME, 0);
	class_addmethod(tracks_class, (t_method)tracks_max_distance, gensym("max_distance"), A_GIMME, 0);
	class_addmethod(tracks_class, (t_method)tracks_weights, gensym("weights"), A_GIMME, 0);
	class_addmethod(tracks_class, (t_method)tracks_spit, gensym("spit"), 0);
	class_addmethod(tracks_class, (t_method)tracks_ft1, gensym("ft1"), A_FLOAT, 0);
	class_addmethod(tracks_class, (t_method)tracks_clear, gensym("clear"), 0);
}

